using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;
using System.Net;
using System.IO;


public partial class demosearch : System.Web.UI.Page
{
    public Hashtable h1 = new Hashtable();
    private string strAccountNo = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            pnlAddress.Visible = false;
        }
        Yell4Postcodewebservice.Lookup objlookup1 = new Yell4Postcodewebservice.Lookup();
    }
    protected void btnFind_Click(object sender, EventArgs e)
    {
        h1.Clear();
        strAccountNo = txtAccountNo.Text.ToString();
        
        if (Postcode.Text.Trim() != "")
        {
            if (Postcode.Text.Length <= 3)
            {
                lblError.Text = "Please enter valid UK Postcode..";
                lstAddress.Visible = false;
                pnlData.Visible = false;
                pnlAddress.Visible = false;
            }
            else
            {
                lblError.Text = "";
                pnlData.Visible = true;
                pnlAddress.Visible = false;
                lstAddress.Items.Clear();


                string strServerMainDown = HttpPost("100", "http://lookup.yell4postcode.co.uk/addresswizardwebservice/lookup.asmx/AddressByID", "aa", "aa", "aa");
                if (strServerMainDown == "server1down")
                {
                    Backupwebservice.Lookup objAW = new Backupwebservice.Lookup();
                    Backupwebservice.InterimResults objResults;
                    Backupwebservice.InterimResult objResult;



                    objResults = objAW.ByPostCode(Postcode.Text.Trim(), strAccountNo);
                    if (objResults.Results.Length != 0)
                    {
                        objResult = (Backupwebservice.InterimResult)objResults.Results[0];
                        if (objResult.ErrorMessage == null)
                        {
                            for (int i = 0; i <= objResults.Results.Length - 1; i++)
                            {

                                objResult = (Backupwebservice.InterimResult)objResults.Results[i];
                                lstAddress.Visible = true;
                                h1.Add(i, objResult.id);
                                ViewState["h1"] = h1;
                                lstAddress.Items.Add(objResult.Description);

                            }
                        }
                        else
                        {
                            lstAddress.Visible = false;
                            pnlData.Visible = false;
                            pnlAddress.Visible = false;
                            lblError.Text = objResult.ErrorMessage;
                        }
                    }
                    else
                    {
                        lstAddress.Visible = false;
                        pnlData.Visible = false;
                        pnlAddress.Visible = false;
                        lblError.Text = "No matching records found...";

                    }

                }
                else
                {
                    Yell4Postcodewebservice.Lookup objAW = new Yell4Postcodewebservice.Lookup();
                    Yell4Postcodewebservice.InterimResults objResults;
                    Yell4Postcodewebservice.InterimResult objResult;



                    objResults = objAW.ByPostCode(Postcode.Text.Trim(), strAccountNo);
                    if (objResults.Results.Length != 0)
                    {
                        objResult = (Yell4Postcodewebservice.InterimResult)objResults.Results[0];
                        if (objResult.ErrorMessage == null)
                        {
                            for (int i = 0; i <= objResults.Results.Length - 1; i++)
                            {

                                objResult = (Yell4Postcodewebservice.InterimResult)objResults.Results[i];
                                lstAddress.Visible = true;
                                h1.Add(i, objResult.id);
                                ViewState["h1"] = h1;
                                lstAddress.Items.Add(objResult.Description);

                            }
                        }
                        else
                        {
                            lstAddress.Visible = false;
                            pnlData.Visible = false;
                            pnlAddress.Visible = false;
                            lblError.Text = objResult.ErrorMessage;
                        }
                    }
                    else
                    {
                        lstAddress.Visible = false;
                        pnlData.Visible = false;
                        pnlAddress.Visible = false;
                        lblError.Text = "No matching records found...";

                    }
                }

               
            }

        }
        else
        {

        }
       
  
    }
    protected void lstAddress_SelectedIndexChanged(object sender, EventArgs e)
    {
        

        Hashtable H2 = new Hashtable();
        H2 = (Hashtable)ViewState["h1"];
        StringBuilder str = new StringBuilder();

        string strServerMainDown = HttpPost("100", "http://lookup.yell4postcode.co.uk/addresswizardwebservice/lookup.asmx/AddressByID", "aa", "aa", "aa");
        if (strServerMainDown == "server1down")
        {
            Backupwebservice.Lookup objLookup = new Backupwebservice.Lookup();
            Backupwebservice.AddressResult objResult;
            Backupwebservice.AddressResults objResults;

            objResults = objLookup.AddressByID(H2[lstAddress.SelectedIndex].ToString());
            objResult = (Backupwebservice.AddressResult)objResults.Results[0];

            str.Remove(0, str.Length);
            if (objResult.OrganisationName.Trim() != "")
                str.Append(objResult.OrganisationName.Trim() + "<br>");
            if (objResult.BuildingNumber.Trim() != "0")
                str.Append(objResult.BuildingNumber.Trim() + " ");
            if (objResult.SubbuildingName.Trim() != "")
                str.Append(objResult.SubbuildingName.Trim() + "<br>");
            if (objResult.BuildingName.Trim() != "")
                str.Append(objResult.BuildingName.Trim() + "<br>");
            if (objResult.ThoroughfareName.Trim() != "")
                str.Append(objResult.ThoroughfareName.Trim() + " ");
            str.Append(objResult.ThoroughfareDescriptor.Trim() + "<br>");
            if (objResult.DependentLocality.Trim() != "")
                str.Append(objResult.DependentLocality.Trim() + "<br>");
            if (objResult.Posttown.Trim() != "")
                str.Append(objResult.Posttown.Trim() + "<br>");
            if (objResult.Outcome.Trim() != "")
                str.Append(objResult.Outcome.Trim() + " ");
            str.Append(objResult.Incode.Trim());
        }
        else
        {
            Yell4Postcodewebservice.Lookup objLookup = new Yell4Postcodewebservice.Lookup();
            Yell4Postcodewebservice.AddressResult objResult;
            Yell4Postcodewebservice.AddressResults objResults;

            objResults = objLookup.AddressByID(H2[lstAddress.SelectedIndex].ToString());
            objResult = (Yell4Postcodewebservice.AddressResult)objResults.Results[0];

            str.Remove(0, str.Length);
            if (objResult.OrganisationName.Trim() != "")
                str.Append(objResult.OrganisationName.Trim() + "<br>");
            if (objResult.BuildingNumber.Trim() != "0")
                str.Append(objResult.BuildingNumber.Trim() + " ");
            if (objResult.SubbuildingName.Trim() != "")
                str.Append(objResult.SubbuildingName.Trim() + "<br>");
            if (objResult.BuildingName.Trim() != "")
                str.Append(objResult.BuildingName.Trim() + "<br>");
            if (objResult.ThoroughfareName.Trim() != "")
                str.Append(objResult.ThoroughfareName.Trim() + " ");
            str.Append(objResult.ThoroughfareDescriptor.Trim() + "<br>");
            if (objResult.DependentLocality.Trim() != "")
                str.Append(objResult.DependentLocality.Trim() + "<br>");
            if (objResult.Posttown.Trim() != "")
                str.Append(objResult.Posttown.Trim() + "<br>");
            if (objResult.Outcome.Trim() != "")
                str.Append(objResult.Outcome.Trim() + " ");
            str.Append(objResult.Incode.Trim());
        }

        pnlData.Visible = false;
        pnlAddress.Visible = true;
        lblAddress.InnerHtml = str.ToString();
  


    }



    public string HttpPost(string payload, string url, string obSSOCookie, string userName, string password)
    {

        HttpWebRequest HttpRequest = (HttpWebRequest)WebRequest.Create(url);

        StreamWriter RequestStream = default(StreamWriter);

        string sRetVal = "";
        System.DateTime dDate = System.DateTime.Now.Date;
        string myUserName = userName;
        string myPassword = password;

        {
            HttpRequest.Method = "POST";
            HttpRequest.Headers.Add("SOAPAction", "\"\"");
            HttpRequest.ContentType = "text/xml";
            HttpRequest.Accept = "text/xml";
            HttpRequest.Timeout = -1;
            //infinite 
            HttpRequest.ContentLength = payload.Length;
            //If username/pw combo is offered, send in credentials w/ webrequest. 
            if (!string.IsNullOrEmpty(myPassword))
            {
                HttpRequest.PreAuthenticate = true;
                HttpRequest.Credentials = new NetworkCredential(myUserName, myPassword);
            }
            else
            {
                HttpRequest.Headers.Add("Cookie", "dummyval");
                HttpRequest.Headers.Add("Cookie", "ObSSOCookie=" + obSSOCookie);
            }
        }

        //Write the request out to the URL specified in WebRequest. 
        try
        {
            RequestStream = new StreamWriter(HttpRequest.GetRequestStream());
            RequestStream.Write(payload);
            RequestStream.Close();
        }
        catch
        {
            sRetVal = "server1down";
        }



        //Get the response back and read it. 

        // & vbCrLf & DateDiff(DateInterval.Second, dDate, Now()) 
        //sRetVal = "";
        return sRetVal;
    } 
}
